var Relation = Class.create({

    initialize: function(left, right, factor, callback, round)
    {
        this.left   = $(left);
        this.right  = $(right);
        this.factor = factor;
        this.callback = callback ? callback:function(){};
        this.round  = round ? Math.pow(10, round):100; //defaut arrondi à 2

        this.bindEvents();
    },

    bindEvents: function()
    {
        this.left.observe('blur', this.modifyLeft.bind(this));
        this.right.observe('blur', this.modifyRight.bind(this));
        this.left.observe('keyup', this.modifyLeft.bind(this));
        this.right.observe('keyup', this.modifyRight.bind(this));
        this.left.observe('focus', this.storeLastValueLeft.bind(this));
        this.right.observe('focus', this.storeLastValueRight.bind(this));
    },

    storeLastValueLeft: function()
    {
        this.left.writeAttribute('lastValue', $F(this.left));
    },

    storeLastValueRight: function()
    {
        this.right.writeAttribute('lastValue', $F(this.right));
    },

    modifyLeft: function()
    {
        if($F(this.left) && $F(this.left) != this.left.readAttribute('lastValue'))
        {
            this.right.value = Math.round($F(this.left).replace(',','.') / this.factor * this.round) / this.round;
        }
        else if( ! $F(this.left))
        {
            this.right.value = '';
        }

        this.callback();
    },

    modifyRight: function()
    {
        if($F(this.right) &&  $F(this.right) != this.right.readAttribute('lastValue'))
        {
            this.left.value = Math.round($F(this.right).replace(',','.') * this.factor * this.round) / this.round;
        }
        else if( ! $F(this.right))
        {
            this.left.value = '';
        }

        this.callback();
    }
    
});